// File boss1.cpp
// implements first boss

#include <GL/glut.h>
#include <stdlib.h>

#include "boss1.h"

// default constructor
Boss1::Boss1( void )
{
  type = 1;
  health = 1000;
  x_pos = 0;
  y_pos = 17;
  angle = 0;
  hitbox_x = 13.0;
  hitbox_y = 6.0;
  movement = 0;
}

// paramaterised constructor
Boss1::Boss1( int t, float x, float y, float a )
{
  type = t;
  x_pos = x;
  y_pos = y;
  angle = a;
  hitbox_x = 0.0;
  hitbox_y = 0.0;
  movement = 0;

  switch ( type )
  {
    case 0:
      health = 0;
      break;

    case 1:
      health = 10;
      break;
  }
}

int Boss1::get_type()
{
  return type;
}

void Boss1::set_health( int amount )
{
  health -= amount;
}

int Boss1::get_health()
{
  return health;
}

int Boss1::getMaxLife()
{
  return 1000;
}

float Boss1::getX()
{
  return x_pos;
}

float Boss1::getY()
{
  return y_pos;
}

float Boss1::get_angle()
{
  return angle;
}

float Boss1::get_hitX()
{
  return hitbox_x;
}

float Boss1::get_hitY()
{
  return hitbox_y;
}

int Boss1::get_movement()
{
  return movement;
}

void Boss1::set_pos( float x, float y )
{
  x_pos += x;
  y_pos += y;
}

void Boss1::set_angle( float new_angle )
{
  angle = new_angle;
}

void Boss1::set_movement( int new_direction )
{
  movement = new_direction;
}

void Boss1::drawBoss1()
{
  switch ( type )
  {
    case 0:
      break;

    case 1:
      GLUquadricObj* disc = gluNewQuadric();
      GLUquadricObj* cylinder = gluNewQuadric();

      // left sponson
      glPushMatrix();
        glTranslatef( -10.0, 0.0, -2.0 );
        glColor3f( 0.5, 0.5, 0.5 );
        gluCylinder( cylinder, 5.0, 5.0, 4.0, 16, 2 );
        glTranslatef( 0.0, 0.0, 4.0 );
        gluDisk( disc, 0.0, 5.0, 16, 2 );
	glTranslatef( 0.0, 0.0, -2.0 );
	glPushMatrix();
	  glTranslatef( -3.0, -4.0, 0.0 );
	  glRotatef( 90.0, 1.0, 0.0, 0.0 );
	  glRotatef( -15.0, 0.0, 1.0, 0.0 );
	  glColor3f( 2.0, 2.0, 2.0 );
	  gluCylinder( cylinder, 0.25, 0.25, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glTranslatef( 0.0, -5.0, 0.0 );
	  glRotatef( 90.0, 1.0, 0.0, 0.0 );
	  gluCylinder( cylinder, 0.25, 0.25, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glTranslatef( 3.0, -4.0, 0.0 );
	  glRotatef( 90.0, 1.0, 0.0, 0.0 );
	  glRotatef( 15.0, 0.0, 1.0, 0.0 );
	  gluCylinder( cylinder, 0.25, 0.25, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glColor3f( 0.2, 0.2, 0.2 );
	  glTranslatef( 0.0, 0.0, 2.5 );
	  glScalef( 2.0, 2.0, 1.0 );
    	  glutSolidCube( 1.0 );
  	  glScalef( 0.5, 0.5, 1.0 );
	  glTranslatef( 5.0, 0.0, 0.5 );
	  glScalef( 8.0, 1.0, 1.0 );
	  glutSolidCube( 1.0 );
	  glTranslatef( 0.0, 0.0, -5.0 );
	  glutSolidCube( 1.0 );
	glPopMatrix();
      glPopMatrix();

      // right sponson
      glPushMatrix();
	glTranslatef( 10.0, 0.0, -2.0 );
	glColor3f( 0.5, 0.5, 0.5 );
	gluCylinder( cylinder, 5.0, 5.0, 4.0, 16, 2 );
	glTranslatef( 0.0, 0.0, 4.0 );
	gluDisk( disc, 0.0, 5.0, 16, 2 );
	glTranslatef( 0.0, 0.0, -2.0 );
	glPushMatrix();
	  glTranslatef( -3.0, -4.0, 0.0 );
	  glRotatef( 90.0, 1.0, 0.0, 0.0 );
	  glRotatef( -15.0, 0.0, 1.0, 0.0 );
	  glColor3f( 2.0, 2.0, 2.0 );
	  gluCylinder( cylinder, 0.25, 0.25, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glTranslatef( 0.0, -5.0, 0.0 );
	  glRotatef( 90.0, 1.0, 0.0, 0.0 );
	  gluCylinder( cylinder, 0.25, 0.25, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glTranslatef( 3.0, -4.0, 0.0 );
	  glRotatef( 90.0, 1.0, 0.0, 0.0 );
	  glRotatef( 15.0, 0.0, 1.0, 0.0 );
	  gluCylinder( cylinder, 0.25, 0.25, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glColor3f( 0.2, 0.2, 0.2 );
	  glTranslatef( 0.0, 0.0, 2.5 );
	  glScalef( 2.0, 2.0, 1.0 );
	  glutSolidCube( 1.0 );
	  glScalef( 0.5, 0.5, 1.0 );
	  glTranslatef( -5.0, 0.0, 0.5 );
	  glScalef( 8.0, 1.0, 1.0 );
	  glutSolidCube( 1.0 );
	  glTranslatef( 0.0, 0.0, -5.0 );
	  glutSolidCube( 1.0 );
	glPopMatrix();
      glPopMatrix();

      // main chassis
      glPushMatrix();
	glColor3f( 0.4, 0.4, 0.4 );
	glScalef( 7.0, 12.0, 4.0 );
	glutSolidCube( 1.0 );
	glPopMatrix();
	glPushMatrix();
	glColor3f( 0.5, 0.5, 0.8 );
	glTranslatef( 0.0, -2.5, 2.0 );
	glScalef( 1.0, 3.0, 2.0 );
	glutSolidSphere( 1.0, 8, 8 );
      glPopMatrix();

      // forward cannons
      glPushMatrix();
	glColor3f( 0.25, 0.25, 0.25 );
	glTranslatef( 0.0, -6.0, 0.0 );
	glRotatef( 90.0, 1.0, 0.0, 0.0 );
	gluCylinder( cylinder, 0.5, 0.5, 2.5, 8, 8 );
	glPushMatrix();
	  glTranslatef( -2.0, 0.0, 0.0 );
	  glRotatef( -15.0, 0.0, 1.0, 0.0 );
	  gluCylinder( cylinder, 0.5, 0.5, 2.5, 8, 8 );
	glPopMatrix();
	glPushMatrix();
	  glTranslatef( 2.0, 0.0, 0.0 );
	  glRotatef( 15.0, 0.0, 1.0, 0.0 );
	  gluCylinder( cylinder, 0.5, 0.5, 2.5, 8, 8 );
	glPopMatrix();
        glPushMatrix();
	  glTranslatef( -3.3, 0.0, 0.0 );
          glRotatef( -35.0, 0.0, 1.0, 0.0 );
          gluCylinder( cylinder, 0.5, 0.5, 2.5, 8, 8 );
        glPopMatrix();
        glPushMatrix();
	  glTranslatef( 3.3, 0.0, 0.0 );
          glRotatef( 35.0, 0.0, 1.0, 0.0 );
          gluCylinder( cylinder, 0.5, 0.5, 2.5, 8, 8 );
        glPopMatrix();
      glPopMatrix();

      break;
  }
}
