// File bullet.cpp
// implements bullet properties

#include <GL/glut.h>
#include <stdlib.h>

#include "bullet.h"

// default constructor
Bullet::Bullet( void )
{
  type = 0;
  x_pos = 0;
  y_pos = 0;
  x_inc = 0;
  y_inc = 0;
  power = 0;
}

// parameterised constructor
Bullet::Bullet( int bullet_type, float xp, float yp, float xs, float ys, int p )
{
  type = bullet_type;
  x_pos = xp;
  y_pos = yp;
  x_inc = xs;
  y_inc = ys;
  power = p;
}

void Bullet::set_pos()
{
  x_pos += x_inc;
  y_pos += y_inc;
}

float Bullet::get_type()
{
  return type;
}

float Bullet::get_x_pos()
{
  return x_pos;
}

float Bullet::get_y_pos()
{
  return y_pos;
}

int Bullet::get_power()
{
  return power;
}

void Bullet::drawBullet()
{
  switch ( type )
  {
    case 1:    // single laser beam type, player-only
      glColor3f( 0.6, 0.6, 0.9 );
      glPushMatrix();
        glRotatef( 45, 0.0, 1.0, 0.0 );
        glScalef( 0.2, 3.0, 0.2 );
        glutSolidCube( 1.0 );
      glPopMatrix();
      break;

    case 2:    // sphere type, orange, player-only
      glColor3f( 0.7, 0.5, 0.3 );
      glPushMatrix();
        glutSolidSphere( 0.3, 7, 7 );
      glPopMatrix();
      break;

    case 3:    // small sphere type, green, enemy-only
      glColor3f( 0.1, 1.0, 0.4 );
      glPushMatrix();
        glutSolidSphere( 0.35, 7, 7 );
      glPopMatrix();
      break;

    case 4:    // huge oval type, boss-only
      glColor3f( 0.5, 0.7, 1.0 );
      glPushMatrix();
        glScalef( 0.5, 1.0, 0.5 );
        glutSolidSphere( 1.0, 12, 12 );
      glPopMatrix();
      break;
  }
}
