// File explosion.cpp
// implements the explosion particle system

#include <GL/glut.h>
#include <stdlib.h>

#include "explosion.h"
#include "particle.h"

// default constructor
Explosion::Explosion( void )
{
  //particles = new Particle[MAX_PARTICLES];
  for ( int i = 0; i < MAX_PARTICLES; i++ )
  {
    particles[i] = Particle( 0.0, 0.0, false );
  }

  x_pos = 0.0;
  y_pos = 0.0;
}

// parameterised constructor
Explosion::Explosion( float x, float y )
{
  x_pos = x;
  y_pos = y;

  //particle[MAX_PARTICLES] particles;
  for ( int i = 0; i < MAX_PARTICLES; i++ )
  {
    particles[i] = Particle( x_pos, y_pos, true );
  }
}

void Explosion::update()
{
  for ( int i = 0; i < MAX_PARTICLES; i++ )
  {
    particles[i].evolveParticle();
  }
}

float Explosion::getX()
{
  return x_pos;
}

float Explosion::getY()
{
  return y_pos;
}

void Explosion::drawExplosion()
{
  for ( int i = 0; i < MAX_PARTICLES; i++ )
  {
    particles[i].drawParticle();
  }
}
