// File particle.cpp
// implements particles

#include <GL/glut.h>
#include <stdlib.h>

#include "particle.h"

// default constructor
Particle::Particle( void )
{
  lifetime = 0;
  decay = 1.0;
  r = 0.0;
  g = 0.0;
  b = 0.0;
  x_pos = 0.0;
  y_pos = 0.0;
  z_pos = 0.0;
  x_spd = 0.0;
  y_spd = 0.0;
  z_spd = 0.0;
  active = false;
}

// parameterised constructor
Particle::Particle( float x, float y, bool activity )
{
  lifetime = (float)(rand()%250)/1000.0;
  decay = 0.00125;
  r = 0.6;
  g = 0.6;
  b = 0.6;
  x_pos = x;
  y_pos = y;
  z_pos = 0.0;

  x_spd = (float) ( 25 - (float)(rand() % 50) ) / 100;
  y_spd = (float) ( 25 - (float)(rand() % 50) ) / 100;
  z_spd = (float) ( 25 - (float)(rand() % 50) ) / 100;
  active = activity;
}

void Particle::evolveParticle()
{
  lifetime -= decay;

  x_pos += x_spd;
  y_pos += y_spd;
  z_pos += z_spd;
  z_spd -= 0.01;
  if ( lifetime <= 0 ) active = false;
}

void Particle::drawParticle()
{
  glPushMatrix();
  if ( active && lifetime > 0.0 )
  {
    glColor3f( r, g, b );
    
    glTranslatef( x_pos, y_pos, z_pos );

    glBegin( GL_TRIANGLE_STRIP );
      glVertex3f( 0.2, 0.2, 0.0 );
      glVertex3f( -0.2, 0.2, 0.0 );
      glVertex3f( 0.2, -0.2, 0.0 );
      glVertex3f( -0.2, -0.2, 0.0 );
    glEnd();    
  }
  glPopMatrix();
}
