// File player1.cpp
// implements the model used for the player1 ship.

#include <GL/glut.h>
#include <stdlib.h>

#include "player1.h"

// default constructor
Player1::Player1( void )
{
  score = 0;
  lives = 3;

  x_pos = -15.0;
  y_pos = -17.0;
  roll_angle = 0.0;

  hitbox_x = 0.75;
  hitbox_y = 0.75;
}

// parameterised constructor
Player1::Player1( int s, int l )
{
  score = s;
  lives = l;

  x_pos = -15.0;
  y_pos = -17.0;
  roll_angle = 0.0;

  hitbox_x = 0.75;
  hitbox_y = 0.75;
}

int Player1::getScore()
{
  return score;
}

int Player1::getLives()
{
  return lives;
}

void Player1::setScore( int points )
{
  score += points;
}

void Player1::setLives( int num )
{
  lives += num;
}

float Player1::getX()
{
  return x_pos;
}

float Player1::getY()
{
  return y_pos;
}

float Player1::getRoll()
{
  return roll_angle;
}

float Player1::get_hitX()
{
  return hitbox_x;
}

float Player1::get_hitY()
{
  return hitbox_y;
}

void Player1::setPos( float x, float y )
{
  x_pos += x;
  y_pos += y;
}

void Player1::setRoll( int direction, int type )
{
  if ( type == 1 )
  {
    if ( roll_angle < 0.0 ) roll_angle += 0.5;
    else roll_angle -= 0.5;
  }
  else
  {
    if ( direction == 0 && roll_angle < 45.0 ) roll_angle += 0.5;
    else if ( direction == 1 && roll_angle > -45.0 ) roll_angle -= 0.5;
  }
}

void Player1::remove_hitbox()
{
  hitbox_x = 0.0;
  hitbox_y = 0.0;
}

void Player1::drawPlayer1()
{
  // fuselage
  glColor3f( 0.6, 0.6, 0.6 );
  glPushMatrix();
    glScalef( 1.0, 3.0, 0.25 );
    glutSolidCube( 0.5 );
  // cockpit
    glPushMatrix();
      glTranslatef( 0.0, 0.05, 0.4 );
      glColor3f( 0.5, 0.5, 0.8 );
      glutSolidSphere( 0.15, 10, 10 );
    glPopMatrix();
  // nose
    glPushMatrix();
      glColor3f( 0.5, 0.5, 0.5 );
      glTranslatef( 0.0, 0.5, 0.0 );
      glScalef( 0.2, 1.0, 0.8 );
      glutSolidCube( 0.5 );
    glPopMatrix();
  // right poton
    glPushMatrix();
      glColor3f( 0.7, 0.7, 0.7 );
      glTranslatef( 0.3, -0.15, 0.0 );
      glutSolidCube( 0.5 );
  // right cannon
      glPushMatrix();
        glColor3f( 0.2, 0.2, 0.3 );
        glTranslatef( 0.0, 0.5, 0.0 );
        glScalef( 0.25, 1.0, 0.7 );
        glutSolidCube( 0.5 );
      glPopMatrix();
  // right fin
      glPushMatrix();
        glTranslatef( 0.1, -0.15, 0.3 );
        glRotatef( 13.0, 0.0, 1.0, 0.0 );
        glScalef( 0.2, 0.3, 0.2 );
        glutSolidCube( 0.5 );
      glPopMatrix();
  // right join
      glPushMatrix();
        glColor3f( 0.7, 0.7, 0.6 );
        glTranslatef( 0.35, 0.0, 0.0 );
        glScalef( 0.35, 0.25, 0.35 );
        glutSolidCube( 0.5 );
  // right wing
	glPushMatrix();
	  glTranslatef( 0.35, 0.0, 0.0 );
          glScalef( 0.5, 2.5, 5.0 );
          glutSolidSphere( 1.0, 10, 10 );
        glPopMatrix();
      glPopMatrix();
    glPopMatrix();
  // left poton
    glPushMatrix();
      glColor3f( 0.7, 0.7, 0.7 );
      glTranslatef( -0.3, -0.15, 0.0 );
      glutSolidCube( 0.5 );
  // left cannon
      glPushMatrix();
        glColor3f( 0.2, 0.2, 0.3 );
        glTranslatef( 0.0, 0.5, 0.0 );
        glScalef( 0.25, 1.0, 0.7 );
        glutSolidCube( 0.5 );
      glPopMatrix();
  // left fin
      glPushMatrix();
        glTranslatef( -0.1, -0.15, 0.3 );
        glRotatef( -13.0, 0.0, 1.0, 0.0 );
        glScalef( 0.2, 0.3, 0.2 );
        glutSolidCube( 0.5 );
      glPopMatrix();
  // left join
      glPushMatrix();
        glColor3f( 0.7, 0.7, 0.6 );
        glTranslatef( -0.35, 0.0, 0.0 );
        glScalef( 0.35, 0.25, 0.35 );
        glutSolidCube( 0.5 );
  // left wing
	glPushMatrix();
	  glTranslatef( -0.35, 0.0, 0.0 );
          glScalef( 0.5, 2.5, 5.0 );
          glutSolidSphere( 1.0, 10, 10 );
        glPopMatrix();
      glPopMatrix();
    glPopMatrix();
  glPopMatrix();
}
