// File title.h
// defines the title screen, shown at startup

#ifndef _TITLE_H_
#define _TITLE_H_

#include <GL/glut.h>
#include <stdlib.h>
#include <string>

using namespace std;

class Title
{
  public:

    Title( void );

    int get_cursor();
    void set_cursor( int direction );
    void set_angle();
    void outputString( float x, float y, string text );
    void set_tex( unsigned int* texList );
    void drawTitle();

  private:

    int cursor;       // cursor position
    float c_size;     // cursor size
    float angle;      // cursor rotation angle
    bool c_inc;       // flag for changing size of cursor
    string start;     // start option
    string quit;      // quit the program
    unsigned int* textures;  // texture list

};

#endif
